package org.apache.commons.lang3.compare;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.apache.commons.lang3.compare.ComparableUtils;

public class ComparableCheckBuilder<A extends Comparable<A>> {
  private final A a;
  
  private ComparableCheckBuilder(A a) {
    this.a = a;
  }
  
  public boolean between(A b, A c) {
    return (betweenOrdered(b, c) || betweenOrdered(c, b));
  }
  
  public boolean betweenExclusive(A b, A c) {
    return (betweenOrderedExclusive(b, c) || betweenOrderedExclusive(c, b));
  }
  
  private boolean betweenOrdered(A b, A c) {
    return (greaterThanOrEqualTo(b) && lessThanOrEqualTo(c));
  }
  
  private boolean betweenOrderedExclusive(A b, A c) {
    return (greaterThan(b) && lessThan(c));
  }
  
  public boolean equalTo(A b) {
    return (this.a.compareTo(b) == 0);
  }
  
  public boolean greaterThan(A b) {
    return (this.a.compareTo(b) > 0);
  }
  
  public boolean greaterThanOrEqualTo(A b) {
    return (this.a.compareTo(b) >= 0);
  }
  
  public boolean lessThan(A b) {
    return (this.a.compareTo(b) < 0);
  }
  
  public boolean lessThanOrEqualTo(A b) {
    return (this.a.compareTo(b) <= 0);
  }
}
